<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  type JsonFormsSubStates,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "ncbi-pubmed-title-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    // For information, if you want to change data in control, you must use control.handleChange()
    let initialValue;
    if (control.control.value.data === undefined) {
      control.handleChange("title", "");
      initialValue = "";
    } else {
      initialValue = control.control.value.data;
    }
    const search = ref();
    const loading = ref();
    const listData = ref();
    const jsonforms = inject<JsonFormsSubStates>("jsonforms");

    if (initialValue !== "") {
      listData.value = [
        {
          title: initialValue,
          value: initialValue,
        },
      ];
    }

    function handle(pathTitle, valueTitle, pathID, valueID) {
      control.handleChange(pathTitle, valueTitle);
      control.handleChange(pathID, valueID);
    }

    const onInput = async (val) => {
      if (!val) return false;
      loading.value = true;
      const baseUrl = "https://eutils.ncbi.nlm.nih.gov/entrez/eutils/";
      try {
        const esearchParams = new URLSearchParams({
          db: "pubmed",
          term: `"${val.trim()}"`,
          retmax: 10,
          retmode: "json",
          field: "title",
        });

        const esearchResponse = await fetch(`${baseUrl}esearch.fcgi?${esearchParams}`);
        if (!esearchResponse.ok) {
          throw new Error("Error during term search");
        }

        const esearchData = await esearchResponse.json();
        const idList = esearchData.esearchresult.idlist;

        if (idList.length === 0) {
          listData.value = [];
        }

        // Récupération des titres avec esummary
        const esummaryParams = new URLSearchParams({
          db: "pubmed",
          id: idList.join(","),
          retmode: "json",
        });

        const esummaryResponse = await fetch(`${baseUrl}esummary.fcgi?${esummaryParams}`);
        if (!esummaryResponse.ok) {
          throw new Error("Error during title collect");
        }

        const esummaryData = await esummaryResponse.json();
        if (esummaryData.result) {
          listData.value = Object.values(esummaryData.result)
            .filter(item => item.uid)
            .map(item => ({
              title: `${item.uid} [${item.title}]`,
              value: `${item.uid}::${item.title}`,
            }));
        } else {
          listData.value = [];
        }
      } catch (error) {
        console.error(error);
      }
      loading.value = false;
    };

    return { ...control, loading, search, jsonforms, handle, onInput, listData };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        // check for incorrect data
        return undefined;
      }
      return suggestions;
    },
  },
  watch: {
    control(value, oldValue) {
      const regex = /^(\d+)\./;
      const match = value.path.match(regex);
      const pos = match ? Number.parseInt(match[1], 10) : null;

      if (
        pos === null
        && "pubmedID" in this.jsonforms.core.data
        && this.jsonforms.core.data.pubmedID.includes("::")
      ) {
        const pathTitle = "title";
        const pathID = "pubmedID";

        const newVal = this.jsonforms.core.data.pubmedID.split("::")[1];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, newVal, pathID, this.jsonforms.core.data.pubmedID.split("::")[0]);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      } else if (
        pos !== null
        && "pubmedID" in this.jsonforms.core.data[pos]
        && this.jsonforms.core.data[pos].pubmedID.includes("::")) {
        const pathTitle = `${pos}.title`;
        const pathID = `${pos}.pubmedID`;
        const newVal = this.jsonforms.core.data[pos].pubmedID.split("::")[1];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, newVal, pathID, this.jsonforms.core.data[pos].pubmedID.split("::")[0]);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      } else if (
        pos !== null
        && "identifier" in this.jsonforms.core.data[pos]
        && "pubmedID" in this.jsonforms.core.data[pos].identifier
        && this.jsonforms.core.data[pos].identifier.pubmedID.includes("::")) {
        const pathTitle = `${pos}.identifier.title`;
        const pathID = `${pos}.identifier.pubmedID`;
        const newVal = this.jsonforms.core.data[pos].identifier.pubmedID.split("::")[1];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, newVal, pathID, this.jsonforms.core.data[pos].identifier.pubmedID.split("::")[0]);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      }
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("ncbi-pubmed-title"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :is-focused="isFocused"
    :applied-options="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-autocomplete
        :id="`${control.id}-input`"
        v-model:search-input="search"
        v-disabled-icon-focus
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        v-bind="vuetifyProps('v-autocomplete')"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :clearable="isHovering"
        :model-value="control.data"
        :items="listData"
        item-value="value"
        :loading="loading"
        @update:model-value="onChange"
        @update:search="onInput"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
